=== OpenGTL/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_definitions( ${OPENGTL_BUILD_DEFINITION} )

add_subdirectory(GTLCore)
if(OPENGTL_BUILD_TESTS)
  add_subdirectory(GTLTest)
endif(OPENGTL_BUILD_TESTS)
add_subdirectory(GTLImageIO)
add_subdirectory(tools)
add_subdirectory(GTLFragment)
