=== OpenRijn/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_definitions( ${OPENGTL_BUILD_DEFINITION} )

set(RIJNC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/rijnc")
set(SHIVAI "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/rijn")
set(RIJNTESTER "${CMAKE_CURRENT_BINARY_DIR}/tools/tester/rijntester")

set(OPENRIJN_VERSION ${OPENGTL_VERSION})
set(OPENRIJN_LIB_VERSION ${OPENGTL_LIB_VERSION})
set(OPENRIJN_LIB_SOVERSION ${OPENGTL_LIB_SOVERSION})

add_subdirectory(OpenRijn)
if(OPENGTL_BUILD_TESTS)
  add_subdirectory(tests)
endif(OPENGTL_BUILD_TESTS)
add_subdirectory(tools)
