=== OpenCTL/tests/CMakeLists.txt ===

add_subdirectory(library)
add_subdirectory(parse)
add_subdirectory(stdlib)
add_subdirectory(arithmetic)
add_subdirectory(statements)
add_subdirectory(misc)
add_subdirectory(complextypes)
add_subdirectory(templates)
