=== OpenCTL/tools/CMakeLists.txt ===
add_subdirectory(compiler)
add_subdirectory(interpreter)
if(NOT MSVC)
  add_subdirectory(benchmark)
endif(NOT MSVC)
add_subdirectory(templatecompiler)
