=== debian/changelog ===
opengtl (0.9.18-0ubuntu3) vivid; urgency=medium

  * Build-depend on llvm-dev.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 10 Dec 2014 11:37:11 +0100

opengtl (0.9.18-0ubuntu2) vivid; urgency=medium

  * Build using llvm-3.5.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 10 Dec 2014 10:30:05 +0100

opengtl (0.9.18-0ubuntu1) trusty; urgency=medium

  * New upstream version.
  * Build using llvm-3.3.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 15:32:53 +0100

opengtl (0.9.16-0ubuntu3) trusty; urgency=medium

  * Build using llvm-3.2.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 15:17:35 +0100
