=== debian/rules ===
#!/usr/bin/make -f

export CXXFLAGS="-std=gnu++11"

%:
	dh $@ --parallel
